<?php
@include_once('inc/config.php');
@include_once('inc/function.php');

if(defined("CONF_READ")){
$sql = array();
$def_char_set = ' DEFAULT CHARACTER SET ujis';
/*=========================================*/
/* ERR MSG                                 */
/*=========================================*/
$msg = array(
'ver02' => 'MySQLС - ',
'log01' => '¸ơ֥<b>'.constant("DB_TABLE_LOG").'</b>Ϻ - ',
'log02' => '¸ơ֥<b>'.constant("DB_TABLE_LOG").'</b> - ',
'con01' => '󥿡¸ơ֥<b>'.constant("DB_COUNTER").'</b>Ϻ - ',
'con02' => '󥿡¸ơ֥<b>'.constant("DB_COUNTER").'</b>Ϻ - ',
'uat01' => 'UserAgent¸ơ֥<b>'.constant("DB_TABLE_UA").'</b>Ϻ - ',
'uat02' => 'UserAgent¸ơ֥<b>'.constant("DB_TABLE_UA").'</b>Ϻ - ',
'set01' => '¸ơ֥<b>'.constant("DB_TABLE_SETTING").'</b>Ϻ - ',
'set02' => '¸ơ֥<b>'.constant("DB_TABLE_SETTING").'</b>Ϻ - ',
'cid01' => 'IDѴꥹ¸ơ֥<b>'.constant("DB_CH_ID").'</b>Ϻ - ',
'cid02' => 'IDѴꥹ¸ơ֥<b>'.constant("DB_CH_ID").'</b>Ϻ - ',
'cul01' => 'URLѴꥹ¸ơ֥<b>'.constant("DB_CH_URL").'</b>Ϻ - ',
'cul02' => 'URLѴꥹ¸ơ֥<b>'.constant("DB_CH_URL").'</b>Ϻ - ',
'exc01' => 'ݥꥹ¸ơ֥<b>'.constant("DB_EXCLUDE").'</b>Ϻ - ',
'exc02' => 'ݥꥹ¸ơ֥<b>'.constant("DB_EXCLUDE").'</b>Ϻ - ',
'del01' => 'ơ֥κ - ',
'del02' => 'ơ֥κ - ',
'def01' => 'ͤɲ - ',
'def02' => 'ͤɲ - ',
);

/*=========================================*/
/* ¸ơ֥                        */
/*=========================================*/
$t = constant("DB_TABLE_LOG");
$sql["log"] = <<<SQL_STR
DROP TABLE IF EXISTS {$t};
CREATE TABLE IF NOT EXISTS {$t} (
  no int(11) NOT NULL auto_increment,
  id varchar(10) NOT NULL default '',
  date datetime NOT NULL default '0000-00-00 00:00:00',
  path tinytext,
  ip varchar(15) default NULL,
  host tinytext,
  ref text,
  ref_q text,
  ua int(5) default NULL,
  title text,
  lang varchar(10) default NULL,
  monitor varchar(15) default NULL,
  color int(10) default NULL,
  cookie int(1) default NULL,
  js int(1) default NULL,
  dl tinytext,
  PRIMARY KEY  (no)
) TYPE=MyISAM{$def_char_set} AUTO_INCREMENT=0;
ALTER TABLE {$t} ADD INDEX iddate (id, date);
ALTER TABLE {$t} ADD INDEX date (date);
SQL_STR;

/*=========================================*/
/* ¸ơ֥                        */
/*=========================================*/
$t = constant("DB_COUNTER");
$sql["con"] = <<<SQL_STR
DROP TABLE IF EXISTS {$t};
CREATE TABLE IF NOT EXISTS {$t} (
  counter_date date NOT NULL default '0000-00-00',
  counter_val int(11) NOT NULL default '0'
) TYPE=MyISAM{$def_char_set};
SQL_STR;

/*=========================================*/
/* UserAgent¸ơ֥                   */
/*=========================================*/
$t = constant("DB_TABLE_UA");
$sql["uat"] = <<<SQL_STR
DROP TABLE IF EXISTS {$t};
CREATE TABLE IF NOT EXISTS {$t} (
  ua_id int(11) NOT NULL auto_increment,
  ua_name text,
  os text,
  os_v varchar(20) default NULL,
  brow text,
  brow_v varchar(20) default NULL,
  PRIMARY KEY  (ua_id)
) TYPE=MyISAM{$def_char_set} AUTO_INCREMENT=0;
ALTER TABLE {$t} ADD INDEX ua_name (ua_name(50));
SQL_STR;

/*=========================================*/
/* ¸ơ֥                        */
/*=========================================*/
$t = constant("DB_TABLE_SETTING");
$sql["set"] = <<<SQL_STR
DROP TABLE IF EXISTS {$t};
CREATE TABLE IF NOT EXISTS {$t} (
  setting_id varchar(255) NOT NULL default '',
  setting_val text NOT NULL,
  PRIMARY KEY  (setting_id)
) TYPE=MyISAM{$def_char_set};
SQL_STR;

/*=========================================*/
/* IDѴꥹ¸ơ֥                */
/*=========================================*/
$t = constant("DB_CH_ID");
$sql["cid"] = <<<SQL_STR
DROP TABLE IF EXISTS {$t};
CREATE TABLE IF NOT EXISTS {$t} (
  ch_id varchar(10) NOT NULL default '',
  ch_name varchar(255) NOT NULL default '',
  PRIMARY KEY  (ch_id)
) TYPE=MyISAM{$def_char_set};
SQL_STR;

/*=========================================*/
/* URLѴꥹ¸ơ֥               */
/*=========================================*/
$t = constant("DB_CH_URL");
$sql["cul"] = <<<SQL_STR
DROP TABLE IF EXISTS {$t};
CREATE TABLE IF NOT EXISTS {$t} (
  ch_url varchar(255) NOT NULL default '',
  ch_urlname text NOT NULL,
  PRIMARY KEY  (ch_url)
) TYPE=MyISAM{$def_char_set};
SQL_STR;

/*=========================================*/
/* ݥꥹ¸ơ֥                  */
/*=========================================*/
$t = constant("DB_EXCLUDE");
$sql["exc"] = <<<SQL_STR
DROP TABLE IF EXISTS {$t};
CREATE TABLE IF NOT EXISTS {$t} (
  exclude_type varchar(20) NOT NULL default '',
  exclude_val text NOT NULL
) TYPE=MyISAM{$def_char_set};
SQL_STR;

/*=========================================*/
/* ơ֥                            */
/*=========================================*/
$sql["del"] = 'DROP TABLE IF EXISTS '.constant("DB_TABLE_LOG").';';
$sql["del"] .= 'DROP TABLE IF EXISTS '.constant("DB_COUNTER").';';
$sql["del"] .= 'DROP TABLE IF EXISTS '.constant("DB_TABLE_UA").';';
$sql["del"] .= 'DROP TABLE IF EXISTS '.constant("DB_TABLE_SETTING").';';
$sql["del"] .= 'DROP TABLE IF EXISTS '.constant("DB_CH_ID").';';
$sql["del"] .= 'DROP TABLE IF EXISTS '.constant("DB_CH_URL").';';
$sql["del"] .= 'DROP TABLE IF EXISTS '.constant("DB_EXCLUDE").';';


/*=========================================*/
/*                               */
/*=========================================*/
$t = constant("DB_TABLE_SETTING");
$sql["def"] = <<<SQL_STR
INSERT INTO {$t} (setting_id, setting_val) VALUES ('def_act', 'top');
INSERT INTO {$t} (setting_id, setting_val) VALUES ('act', '[]\r\ntop||ȥå\r\nsearch||\r\nsearchEncoded||󥳡ɸ\r\n[ֲ]\r\ntime||\r\nday||\r\nweek||\r\nmonth||\r\ntransit||\r\n[󥯸]\r\npage||ڡ\r\npage2||ڡ2\r\nref||󥯸\r\neng||󥸥\r\nkeyword||\r\n[桼Ķ]\r\nos||OS\r\nbrowser||֥饦\r\nlang||\r\nuser_env||桼Ķ\r\narea||ϰ\r\n[³]\r\ndomain||ɥᥤ\r\nisp||ISP\r\nhost||ۥ\r\n[]\r\ntrack||桼\r\ntrackaday||̥桼\r\nbot||\r\n[¾]\r\nraw_log||\r\ndownload||\r\np_sel||ڡ');
INSERT INTO {$t} (setting_id, setting_val) VALUES ('skin', 'mogura');
SQL_STR;
}

/*=========================================*/
/* DEFAULT CHARACTER SETͭ/̵Ƚ  */
/*=========================================*/
function isDefCharSetDisabled(&$def_char_set_disabled){
	global $db,$msg;
	$def_char_set_disabled = true;
	
	$res = $db->query('SELECT VERSION();');
	if(DB::isError($res)){
		echo '<p class="err">&gt; '.$msg['ver02'].'</p>';
		echo '<p class="def">ڥ顼ơ</p>';
		echo '<p class="def">Error Message: <b>' . $res->getMessage() . "</b></p>\n";
		echo '<p class="def">Debug: <b>' . $res->getDebugInfo() . "</b></p>\n";
		
		return false;
	}
	
	$row = $res->fetchRow(DB_FETCHMODE_ORDERED);
	if($row && !preg_match('/^(3\.|4\.0).*/', trim($row[0]))){
		$def_char_set_disabled = false;
	}
	
	$res->free();
	
	return true;
}

/*=========================================*/
/* SQL                                 */
/*=========================================*/
function q($sql_key, $def_char_set_disabled){
	global $db,$sql,$def_char_set,$msg;
	
	$flg = true;
	foreach (explode(";", $sql[$sql_key]) as $v) {
		if(!$flg) break;
		$v = trim($v);
		if(!$v){
			continue;
		}else{
			$v .= ";";
		}
		$v = @mb_convert_encoding($v, "EUC-JP", "ASCII,JIS,UTF-8,EUC-JP,SJIS");
		if($def_char_set_disabled){
			$v = str_replace($def_char_set, '', $v);
		}
		$res = $db->query($v);
		$flg = (DB::isError($res) ? false : true);
	}
	if($flg){
		echo '<p>&gt; '.$msg[$sql_key."01"].'</p>';
	}else{
		echo '<p class="err">&gt; '.$msg[$sql_key."02"].'</p>';
		echo '<p class="def">ڥ顼ơ</p>';
		echo '<p class="def">Error Message: <b>' . $res->getMessage() . "</b></p>\n";
		echo '<p class="def">Debug: <b>' . $res->getDebugInfo() . "</b></p>\n";
	}
	return $flg;
}
/*=========================================*/
/* PEAR å                           */
/*=========================================*/
function file_exists_ex($path, $use_include_path = true){
    if($use_include_path == false) return file_exists($path);
    // check if absolute
    if (is_absolute_path($path)) return file_exists($path);
    $include_path_list = explode(PATH_SEPARATOR, get_include_path());
    if(is_array($include_path_list) == false) return file_exists($path);
    foreach ($include_path_list as $include_path) {
        if(file_exists($include_path . DIRECTORY_SEPARATOR . $path)) return true;
    }
    return false;
}
function is_absolute_path($path){
	if (OS_WINDOWS) {
		if(preg_match('/^[a-z]:/i', $path) && $path{2} == DIRECTORY_SEPARATOR) return true;
	}else{
	if ($path{0} == DIRECTORY_SEPARATOR) return true;
}
	return false;
}

$pear_inc_ok = true;
if($pear_inc_ok) $pear_inc_ok = file_exists_ex('PEAR.php') ? true : false;
if($pear_inc_ok) $pear_inc_ok = file_exists_ex('DB.php') ? true : false;
if($pear_inc_ok) $pear_inc_ok = file_exists_ex('DB/'.constant("DB_TYPE").'.php') ? true : false;

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=euc-jp">
<meta name="robots" content="noindex,nofollow,noarchive">
<style type="text/css">
<!--
BODY {
	letter-spacing: 0.2em;
	font-family: Verdana, Arial, "MS UI Gothic", Osaka, Helvetica, sans-serif;
	background-color: #EEE;
	margin: 30px;
	padding: 0px;
	font-size: 12px;
	background-image: none;
}
A         { color: #36C; }
A:link    { text-decoration: none; }
A:visited { text-decoration: none; }
A:hover   { text-decoration: underline; color: #F30; }
p {
	margin-left: 30px;
	color: #00C;
}
.def{
	color: #333;
}
.err{
	color: #C00;
}
#copy{
	font-size: 10px;
	color: #333333;
	text-align: right;
}
//-->
</style>
<title>mogura - Setup</title>
</head>
<body>
<h2>mogura - Setup</h2>
<?php

flush();
if(defined("CONF_READ")){
	$_GET["step"] = isset($_GET["step"]) ? $_GET["step"] : "";
	switch ($_GET["step"]) {
	case 1:
	   echo '<p class="def">åȥåפȥ<b>ƤΥǡ</b>ΤդƤ</p>';
	   echo '<p class="err">åȥåפ¹Ԥޤ</p>';
	   echo '<p class="def"><a href="setup.php"></a><a href="setup.php?step=2">Ϥ</a></p>';
	   break;
	case 2:
	   echo '<p class="def">åȥåפ򳫻Ϥޤ</p>';
		// DB³
		$db = DB::connect(constant("DSN"));
		if(DB::isError($db)){
			echo '<p class="err">&gt; ǡ١<b>'.constant("DB_NAME").'</b>Ϥ³ޤǤ</p>';
			echo '<p class="err">&gt; config.phpΥǡ١ľƤ</p>';
			echo '<p class="err">&gt; ǡ١<b>'.constant("DB_NAME").'</b>ϤƤ뤫ǧƲ</p>';
			echo '<p class="def">ڥ顼ơ</p>';
			echo '<p class="def">Error Message: <b>' . $db->getMessage() . "</b></p>\n";
			echo '<p class="def">Debug: <b>' . $db->getDebugInfo() . "</b></p>\n";
		   echo '<p class="def"><a href="setup.php"></a></p>';
		}else{
			$db->query("SET NAMES UJIS;");
			$db_flg = true;
			$def_char_set_disabled = true;
			echo '<p>&gt; DB³</p>';
			if($db_flg) $db_flg = isDefCharSetDisabled($def_char_set_disabled);
			if($db_flg) $db_flg = q("log", $def_char_set_disabled);
			if($db_flg) $db_flg = q("con", $def_char_set_disabled);
			if($db_flg) $db_flg = q("uat", $def_char_set_disabled);
			if($db_flg) $db_flg = q("set", $def_char_set_disabled);
			if($db_flg) $db_flg = q("cid", $def_char_set_disabled);
			if($db_flg) $db_flg = q("cul", $def_char_set_disabled);
			if($db_flg) $db_flg = q("exc", $def_char_set_disabled);
			if($db_flg) $db_flg = q("def", false);
			
			$db->disconnect();
			echo '<p>&gt; DB</p>';
			
			if($db_flg){
				echo '<p class="def"><a href="setup.php?step=3"></a></p>';
			}else{
				echo '<p class="def"><a href="setup.php?step=4"></a></p>';
			}
		}
	   break;
	case 3:
		echo '<p>˥åȥå׽λޤ</p>';
		echo '<p class="def"><b>setup.php</b>򥵡СƤ</p>';
		echo '<p class="def"> <a href="control_panel/cp.php?mode=log_w">ѥɳǧڡ򳫤</a>ʥȥѥͥ</p>';
		echo '<p class="def"> <a href="w3a.php">Moguraᥤ̤򳫤</a></p>';
		echo '<p class="def"> <a href="setup.php">setup.phpȥå</a></p>';
	   break;
	case 4:
		echo '<p class="err">˥åȥå׽λޤǤ</p>';
		echo '<p class="def"> <a href="setup.php">setup.phpȥå</a></p>';
	   break;

	case 11:
	   echo '<p class="def">ǡ١moguraϢ<b>ǡڤӥơ֥</b>ޤ</p>';
	   echo '<p class="err">󥻥åȥåפ¹Ԥޤ</p>';
	   echo '<p class="def"><a href="setup.php"></a><a href="setup.php?step=12">Ϥ</a></p>';
	   break;
	case 12:
	   echo '<p class="def">󥻥åȥåפ򳫻Ϥޤ</p>';
		// DB³
		$db = DB::connect(constant("DSN"));
		if(DB::isError($db)){
			echo '<p class="err">&gt; DB³ޤǤ</p>';
			echo '<p class="def">ڥ顼ơ</p>';
			echo '<p class="def">Error Message: <b>' . $db->getMessage() . "</b></p>\n";
			echo '<p class="def">Debug: <b>' . $db->getDebugInfo() . "</b></p>\n";
		}else{
			$db->query("SET NAMES UJIS;");
			$db_flg = true;
			echo '<p>&gt; DB³</p>';
			if($db_flg) $db_flg = q("del", false);
			$db->disconnect();
			echo '<p>&gt; DB</p>';
			
			if($db_flg){
				echo '<p class="def"><a href="setup.php?step=13"></a></p>';
			}else{
				echo '<p class="def"><a href="setup.php?step=14"></a></p>';
			}
		}
	   break;
	case 13:
		echo '<p>˥󥻥åȥå׽λޤ</p>';
		echo '<p class="def"><b>moguraϢΥե</b>򥵡СƤ</p>';
		echo '<p class="def"> <a href="setup.php">setup.phpȥå</a></p>';
	   break;
	case 14:
		echo '<p class="err">˥󥻥åȥå׽λޤǤ</p>';
		echo '<p class="def"> <a href="setup.php">setup.phpȥå</a></p>';
	   break;


	default:
	   echo '<p class="def">ΥץȤ<b>PHPϡmogura</b>򥻥åȥåפ٤ΤΤǤ</p>';
		if($pear_inc_ok){
	   	echo '<p> PEARɤ߹ޤƤޤ</p>';
		   echo '<p class="def"> <a href="setup.php?step=1">åȥå</a></p>';
		   echo '<p class="def"> <a href="setup.php?step=11">󥻥åȥå</a>moguraϢơ֥κ</p>';
	   }else{
	   	echo '<p class="err"> PEARɤ߹ߤ˼Ԥޤ</p>';
	   	echo '<p class="err">ڰʲΥե¸ߡѥǧƤ</p>';
	   	echo '<p class="err">PEAR.php , DB.php , DB/'.constant("DB_TYPE").'.php</p>';
	   }
	}
}else{
	echo '<p class="err">config.phpɤ߹ߤ˼Ԥޤ</p>';
}
?>
<div id="copy"><hr size="1"><a href="http://fmono.sub.jp/" target="_blank">&copy;&nbsp;OSAKA&nbsp;PHP</a>&nbsp;/&nbsp;Edit&nbsp;:&nbsp;<a href="http://tekito.jp/" target="_blank">tekito</a></div>
</body>
</html>
